import config from "../config/index";
// import { ElMessage } from 'element-plus'

function getdata(data){
  let text = ""
  for (const key in data) {
    text += key + '=' + data[key] + '&';
  }
  text ? text = '?' + text : ""
  text = text.replace(/&$/, '')
  return text
}

export default function (ori) {
  let url = config.base.url + ori.url + getdata(ori.data || {})
  if(ori.downCsv) return window.open(url)
  return new Promise((resolve, reject) => {
    var xhttp;
    if (window.XMLHttpRequest) xhttp = new XMLHttpRequest();
    else if (window.ActiveXObject)
      xhttp = new window.ActiveXObject("Microsoft.XMLHTTP");
    let method = ori.method.toUpperCase();
    xhttp.open(method, url, true);
    method === "GET" ? xhttp.send() : xhttp.send(JSON.stringify(ori.data));
    xhttp.onreadystatechange = function() {
      if (this.readyState != 4 || this.status != 200) return;
      let data = {};
      try{
        data = JSON.parse(this.responseText || '{}');
      }catch(err){
        console.error(err)
        reject(err)
      }
      data.response && (data = data.response)
      if(!data.status) {
        // ElMessage({
        //   message: '请求走丢了',
        //   type: 'warning',
        // })
        return reject(data.message)
      }
      resolve(data.data || data.response)
    };
  });
}
